
let rec custom_foldr f = function 
  | [a;b] -> f a b
  | [a] -> a
  | a::l -> f a (custom_foldr f l)
  | [] -> failwith "parsing : empty applicative list"

let string_of_char_list l = 
	let n = List.length l in 
	let s = String.make n 'X' in
	let rec worker i = function
		| [] -> ()
		| c::l -> s.[i] <- c ; worker (i+1) l
	in worker 0 l ; s
