{
  open Parser
}

let lambda = "\206\187"

rule token = parse
  | [' ' '\t']      {token lexbuf} (* skip blanks *)
  | ['0'-'9']+      { INT(int_of_string(Lexing.lexeme lexbuf)) }
  | '\\' | lambda   { LAMBDA }
  | ['a'-'z']       { ID((Lexing.lexeme lexbuf).[0]) }
  | '@'		    { APP_FOCUS }
  | '('             { LPAREN }
  | ')'             { RPAREN }
  | '.'             { POINT }
  | 'S'             { SUCC }
  | 'Y'             { FIXP }
  | "if"            { IF }
  | "iszero"        { ISZERO }
  | "pred"          { PRED }
  | '='		    { EQUAL }
  | '+'		    { PLUS }
  | '*'		    { TIMES }
  | '-'		    { MINUS }
  | "not"	    { NOT }
  | '&'		    { AND }
  | '|'		    { OR }
  | '\n'            { NEWLINE }
  | eof             { EOF }
