%{
  open Lambda
  open Common
%}

%token EOF
%token NEWLINE
%token <int> INT
%token <char> ID
%token LAMBDA
%token POINT
%token APP_FOCUS
%token SUCC
%token FIXP
%token ISZERO
%token PRED
%token IF
%token EQUAL
%token PLUS
%token TIMES
%token MINUS
%token NOT
%token AND
%token OR
%token LPAREN RPAREN
%start main
%type <Lambda.lambda> main

%%

main:
        lambda NEWLINE           { $1 }
;


slambda:
| INT                               { Integer $1 }
| ID                                { Var ((int_of_char $1)-97) }
| SUCC                              { S }
| IF                                { If }
| ISZERO                            { IsZero }
| PRED                              { Pred }
| FIXP                              { Fixpoint }
| EQUAL				    { Equal }
| PLUS				    { Plus }
| TIMES				    { Times }
| MINUS				    { Minus }
| NOT				    { Not }
| AND				    { And }
| OR				    { Or }
| LPAREN lambda RPAREN              { $2 }
| LAMBDA id_list POINT lambda       { List.fold_right (fun a b -> Abstr(a,b))(List.map (fun c -> ((int_of_char c)-97)) $2) $4 }
| EOF                               { raise End_of_file }
;

lambda:
| slambda                        { $1 }
| lambda slambda                 { App($1,$2) }
| lambda APP_FOCUS slambda	 { AppFoc($1,$3) }


id_list:
| ID id_list                     { $1::$2 }
| ID                             { [$1] }
;
