open Lambda
open Interaction 

let delta = Abstr(0,App(Var 0,Var 0))

let y = Abstr(0,
	      App(
		Abstr(1,App(Var 0,App(Var 1,Var 1))),
		Abstr(1,App(Var 0,App(Var 1,Var 1)))))

let succ = Abstr(0,
		 Abstr(1,
		       Abstr(2,
			     App(
			     App(Var 0, Var 1),
			       App(Var 1, Var 2)))))

let plus = Abstr(0,
		 Abstr(1,
		       Abstr(2,
			     Abstr(3,
				   App(
				     App(Var 0,Var 2),
				     App(
				       App(Var 1,Var 2),
				       Var 3))))))

let mult = Abstr(0,
		 Abstr(1,
		       Abstr(2,
			     App(Var 0,
				 App(Var 1, Var 2)))))


let l_true = Abstr(0, Abstr(1,Var 0))

let l_false = Abstr(0, Abstr(1,Var 1))

let iszero = Abstr(0,App(App(Var 0,Abstr(0,l_false)),l_true))

(* predecessor for the church integers in pure lambda calculus : 
 * λ n f x. n (λ g h. h (g f)) (λ u. x) (λ u. u) 
 *)

let pred = Abstr(0,Abstr(1,Abstr(2,App(App(App(Var 0,Abstr(3,Abstr(4,App(Var 4,App(Var 3,Var 1))))),Abstr(0,Var 2)),Abstr(0,Var 0)))))
				 


let fact_fonct = Abstr(0,
		       Abstr(1,
			     App(App(App(iszero,Var 1),Abstr(0,Abstr(1,App(Var 0,Var 1)))),
				 App(App(mult,Var 1),App(Var 0, App(pred,Var 1))))
			    )
		      )

let factor = App(y,fact_fonct)

	

let church_integer i =
  let rec iterate_int = function 
    | 0 -> Var 1
    | n -> App(Var 0,iterate_int (n-1))
  in Abstr(0,Abstr(1,iterate_int i))

let n = 14

let test = [|(delta,delta);
	     (S,O);
	     (App(church_integer 5,S),O);
	     (App(church_integer 10,S),O);
	     (App(App(church_integer 1, church_integer 1),S),O);
	     (App(App(church_integer 3, church_integer 3),S),O);
	     (App(App(App(plus, church_integer 10), church_integer 7),S),O);
	     (App(App(App(mult, church_integer 9), church_integer 9),S),O);
	     (App(l_true,App(S,O)),O);
	     (App(l_false,App(S,O)),O);
	     (App(Abstr(0,Var 0),App(S,O)),O);
	     (App(App(iszero,church_integer 0),App(S,O)),O);
	     (App(App(pred,church_integer 9),S),O);
	     (App(App(factor,church_integer 2),S),O);
	     (Abstr(0,App(App(Var 0,S),Integer 0)),church_integer 1) 
	       

	   
	   
	   |]



let i = init_interp (App(fst (test.(n)), snd test.(n))) 0

let print_action = function
  | Interaction.InTau _ -> output_string stderr "Interaction in progress...\n"
  | Interaction.Ready_o -> output_string stderr "Interaction finished.\n"
  | _  -> output_string stderr  "something else\n"

let p = match i with 
	| i -> 
		(
		  match 
		    0
		  with 
		    | 0 -> i.Interaction.play
		    | 1 -> 
			(
			  match i.Interaction.strategies.(0).Interaction.agent with 
			    | Interaction.Interaction i -> i.Interaction.play
			    | _ -> failwith "rien" 
			)
		    | 2 -> 
			(
			  match i.Interaction.strategies.(1).Interaction.agent with 
			    | Interaction.Interaction i -> i.Interaction.play
			    | _ -> failwith "rien" 
			)
		    | 3 -> 
			(
			  match i.Interaction.strategies.(0).Interaction.agent with 
			    | Interaction.Interaction i ->
				(
				  match i.Interaction.strategies.(0).Interaction.agent with 
				    | Interaction.Interaction i -> i.Interaction.play
				    | _ -> failwith "rien" 
				)
			    | _ -> failwith "rien"
			) 
		    | 4 -> 
			(
			  match i.Interaction.strategies.(0).Interaction.agent with 
			    | Interaction.Interaction i ->
				(
				  match i.Interaction.strategies.(0).Interaction.agent with 
				    | Interaction.Interaction i -> 
					(
					  match i.Interaction.strategies.(1).Interaction.agent with 
					    | Interaction.Tensor(ag1,ag2) ->
						(
						  match ag2 with 
						    | Interaction.Interaction i -> i.Interaction.play
						    | _ -> failwith "rien1"
						)
					    | _ -> failwith "rien2"
					)
				    | _ -> failwith "rien3" 
				)
			    | _ -> failwith "rien4"
			) 
		    | 5 -> 
			(
			  match i.Interaction.strategies.(0).Interaction.agent with 
			    | Interaction.Interaction i ->
				(
				  match i.Interaction.strategies.(0).Interaction.agent with 
				    | Interaction.Interaction i -> 
					(
					  match i.Interaction.strategies.(0).Interaction.agent with 
					    | Interaction.Interaction i -> i.Interaction.play
					    | _ -> failwith "rien"
					)
				    | _ -> failwith "rien" 
				)
			    | _ -> failwith "rien"
			) 
		    | 6 -> 
			(
			  match i.Interaction.strategies.(0).Interaction.agent with 
			    | Interaction.Interaction i ->
				(
				  match i.Interaction.strategies.(0).Interaction.agent with 
				    | Interaction.Interaction i -> 
					(
					  match i.Interaction.strategies.(0).Interaction.agent with 
					    | Interaction.Interaction i -> 
						(
						  match i.Interaction.strategies.(0).Interaction.agent with 
						    | Interaction.Interaction i -> i.Interaction.play
						    | _ -> failwith "rien"
						)
					    | _ -> failwith "rien"
					)
				    | _ -> failwith "rien" 
				)
			    | _ -> failwith "rien"
			)
		    | _ -> failwith "rien5"
		)

exception Computation_finished
exception Computation_failure

let _ =
  try
    let n = int_of_string (Sys.argv.(1))
    in
      try 
	for j=0 to n do
	  match (Interaction.step (Interaction.Interaction i)) with 
	    | InTau _ as a -> Debug.debug (string_of_status a)
	    | Ready_i | Ready_o as a -> 
		Debug.debug (string_of_status a);
		raise Computation_finished
	    | _ -> raise Computation_failure
	done;
	raise Computation_finished
      with 
	| Computation_finished -> 
	    
	    let h = Dump.play_to_hashtbl p in
	    let v = Dump.hashtbl_to_vector h in
	    let s = Dump.vector_to_string v in
	      Pervasives.output_string stdout "
matrix {\n";
	      Pervasives.output_string stdout s;
	      Pervasives.output_string stdout "
}"
	| e -> raise e
  with
    | Invalid_argument s when s="index_out_of_bounds" ->
	output_string stderr "Invalid usage.\n\n./omega [--new] integer\n";
	exit 1
    | e -> raise e
